/*
 * readln.c
 * Reads a line from the keyboard and stores it as a C-style text string.
 *	theString is address of place to store the string
 *	limit specifies maximum number of chars, including '\0', to store
 * 	returns number of characters (excluding '\0') stored
 * Robert G. Plantz - 21 December 2003
 */

#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include "readln.h"

int readln(char *theString, int limit) {
	int counter = 0;
	limit--;	/* leave space for '\0' */
	read(STDIN_FILENO, theString, 1);
	while((*theString != '\n') && (counter < limit)) {
		theString++;
		counter++;
		read(STDIN_FILENO, theString, 1);
	}
	
	while(*theString != '\n') {
		read(STDIN_FILENO, theString, 1);
	}
	
	*theString = '\0';
	
	return counter;
}

