/*
 * sDecToInt.c
 * Takes the address of a C-style text string.
 *	The first character may be either '+', '-', or a decimal numeral.
 *	(Leading '+' is allowed but not required for a nonnegative integer.)
 *	Following the first character, the string has only decimal numerals.
 *	Assumes the represented integer does not exceed 32 bits of storage.
 *	Converts the string & returns the corresponding signed int.
 * David Bozarth - 18 February 2004
 */

#include "sDecToInt.h"
#include "uDecToInt.h"

int sDecToInt(char *theString) {
	int x, count;
	int isNeg;		/* flag: if nonzero then negative int */
	char aChar;

	x = 0; count = 0; isNeg = 0;

	aChar = *theString;		/* inspect first char for sign */
	if (aChar == '-' || aChar == '+') {
		if (aChar == '-') {
			isNeg = -1;
		}
		aChar = *(++theString);	/* done with sign char */
	}
	
	/*
	  while ( aChar != '\0' )*/	/* parse & convert string to int
	{	
		x *= 10;
		x += (aChar & 0x0f);
		aChar = *(theString + ++count);
	}
	*/

	x = (int) uDecToInt(theString); /* parse & convert string to int */

	if (isNeg) {
		x = -x;
	}
	
	return x;
}
