/*
 * sIntToDec.c
 * Takes signed int, and the address of a char array.
 *	Converts the int to a decimal text string representing the int.
 * 	Negative integers will be rendered with a leading '-'.
 *	Non-negative integers will receive no leading sign character.
 *	Returns the number of characters in the string (not including NUL).
 * David Bozarth - 18 February 2004
 */

#include "sIntToDec.h"
#include "uIntToDec.h"

int sIntToDec(int theInt, char *theString) {
	int rem;			/* remainder */
	int left, right; 	/* string position pointers */
	int count;
	int isNeg;			/* flag: if nonzero then negative int */
	int i;
	char aChar;
	char* ptr;

	if (theInt == 0) {
		*theString = '0';
		*(theString + 1) = '\0';
		return 1;				/* all done if zero */
	}
	
	left = 0; right = 0; isNeg = 0;
	
    if (theInt < 0) {			/* check & record sign of int */
    	isNeg = -1;
    	theInt = -theInt;
    }

/* 	following section tested OK as standalone code 20040215 */
/*	.. was replaced with call to uIntToDec() and new sign-handling 20040218 */
/*
	while (theInt != 0) {		/* convert int to string	
		rem = (theInt % 10);
		rem |= 0x30; 			/* mask binary to ascii

		*(theString + right++) = rem;
		theInt /= 10;
	}
		
	if (isNeg) {
		*(theString + right++) = '-';
	}
	
	*(theString + right) = '\0';
	count = right;	/* done making a backward, signed decimal C-string

	while (left < right) {		/* invert the string
		aChar = *(theString + left);
		*(theString + left++) = *(theString + --right);
		*(theString + right) = aChar;
	}
*/
	
	count = (int) uIntToDec(theInt, theString);
	
	if (isNeg) { 	/* right-shift string to make space for '-' */
		ptr = theString + count;
		*(ptr + 1) = '\0';
		
		for (i = count; i > 0; --i) {
			*ptr = *(--ptr);
		}
		*theString = '-';
	}	
	
	return count;
}
