/*
 * echo_line.c
 * Asks user to enter a text string
 * then echoes it
 * adapted from Robert G. Plantz - 21 December 2003
 * adapted by David Bozarth - 15 February 2004
 */

#include <stdio.h>
#include "writestr.h"
#include "readln.h"
#include "uDecToInt.h"
#include "sDecToInt.h"
#include "uIntToDec.h"
#include "sIntToDec.h"

#define BUFFER_SIZE 10

int main(void)
{
	int nChars;		/* we use this for debugging */
	int sidec;
	unsigned int undec;
	char buffer[BUFFER_SIZE];
	
	nChars = writestr("Please enter a decimal integer: ");
	nChars = readln(buffer, BUFFER_SIZE);

	/* nChars = checkStr(buffer); */
	if ( *buffer == '+' || *buffer == '-' ) {
		sidec = 10 * sDecToInt(buffer);
		nChars = sIntToDec(sidec, buffer);
	} else {
		undec = 10 * uDecToInt(buffer);
		nChars = uIntToDec(undec, buffer);
	}

	nChars = writestr("You entered\n\t");
	nChars = writestr(buffer);
	
	printf("\nEnd of program.\n");
	
	exit(0);
}
