/*
 * uIntToDec.c
 * Takes an unsigned int, and the address of a char array.
 *	Converts the int to a decimal text string representing the int.
 *	Returns the number of characters in the string (not including NUL).
 * David Bozarth - 15 February 2004
 */

#include "uIntToDec.h"

int uIntToDec(unsigned int theInt, char *theString) {
	int rem;			/* remainder */
	int left, right; 	/* string position pointers */
	int count;
	char aChar;

	if (theInt == 0) {
		*theString = '0';
		*(theString + 1) = '\0';
		return 1;				/* all done if zero */
	}

	left = 0; right = 0;

	while (theInt != 0) {		/* convert int to string */	
		rem = (theInt % 10);
		rem |= 0x30; 			/* mask binary to ascii */
		*(theString + right) = rem;

		theInt /= 10;
		++right;
	}

	*(theString + right) = '\0';
	count = right;

	while (left < right) {		/* invert the string */
		aChar = *(theString + left);
		*(theString + left++) = *(theString + --right);
		*(theString + right) = aChar;
	}

	return count;
}
